MyGUI: MyGUI::ComboBox Class Reference

MyGUI 3.4.3

Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions
MyGUI::ComboBox Class Reference

widget description should be here. More...

`#include <MyGUI_ComboBox.h>`

Inheritance diagram for MyGUI::ComboBox:
[legend]

## Public Types
typedef RTTIBase | Base
typedef ComboBox | RTTIBase
Public Types inherited from MyGUI::EditBox
typedef RTTIBase | Base
typedef EditBox | RTTIBase
Public Types inherited from MyGUI::TextBox
typedef RTTIBase | Base
typedef TextBox | RTTIBase
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual std::string_view | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type>
bool | isType () const
size_t | getItemCount () const
| Get number of items.
void | insertItemAt (size_t _index, const UString &_item, Any _data=Any::Null)
| Insert an item into a array at a specified position.
void | addItem (const UString &_name, Any _data=Any::Null)
| Add an item to the end of a array.
void | removeItemAt (size_t _index)
| Remove item at a specified position.
void | removeAllItems ()
| Remove all items.
size_t | findItemIndexWith (const UString &_name)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.
size_t | getIndexSelected () const
| Get index of selected item (ITEM_NONE if none selected)
void | setIndexSelected (size_t _index)
| Select specified _index.
void | clearIndexSelected ()
| Clear item selection.
void | setItemDataAt (size_t _index, Any _data)
| Replace an item data at a specified position.
void | clearItemDataAt (size_t _index)
| Clear an item data at a specified position.
template<typename ValueType>
ValueType * | getItemDataAt (size_t _index, bool _throw=true)
| Get item data from specified position.
void | setItemNameAt (size_t _index, const UString &_name)
| Replace an item name at a specified position.
const UString & | getItemNameAt (size_t _index) const
| Get item name from specified position.
void | beginToItemAt (size_t _index)
| Move all elements so specified becomes visible.
void | beginToItemFirst ()
| Move all elements so first becomes visible.
void | beginToItemLast ()
| Move all elements so last becomes visible.
void | beginToItemSelected ()
| Move all elements so selected becomes visible.
void | setComboModeDrop (bool _drop)
| Set drop list mode (text can not be edited)
bool | getComboModeDrop () const
| Get drop list mode flag.
void | setSmoothShow (bool _value)
| Set smooth show of list.
bool | getSmoothShow () const
| Get smooth show of list flag.
void | setMaxListLength (int _value)
| Get max list length.
int | getMaxListLength () const
| Set max list length.
void | setFlowDirection (FlowDirection _value)
| Set direction, where drop down list appears (TopToBottom by default).
FlowDirection | getFlowDirection () const
| Get direction, where drop down list appears.
size_t | _getItemCount () const override
void | _addItem (const MyGUI::UString &_name) override
void | _removeItemAt (size_t _index) override
void | _setItemNameAt (size_t _index, const UString &_name) override
const UString & | _getItemNameAt (size_t _index) const override
void | _resetContainer (bool _update) override
Public Member Functions inherited from MyGUI::EditBox
template<typename Type>
bool | isType () const
| EditBox ()
void | setTextIntervalColour (size_t _start, size_t _count, const Colour &_colour)
size_t | getTextSelectionStart () const
size_t | getTextSelectionEnd () const
size_t | getTextSelectionLength () const
UString | getTextInterval (size_t _start, size_t _count) const
void | setTextSelection (size_t _start, size_t _end)
void | deleteTextSelection ()
UString | getTextSelection () const
bool | isTextSelection () const
void | setTextSelectionColour (const Colour &_colour)
void | setTextCursor (size_t _index)
size_t | getTextCursor () const
void | setCaption (const UString &_value) override
const UString & | getCaption () const override
void | setOnlyText (const UString &_text)
UString | getOnlyText () const
size_t | getTextLength () const
void | setOverflowToTheLeft (bool _value)
| Sets if surplus characters should push characters off the left side rather than ignored.
bool | getOverflowToTheLeft () const
| Returns true if surplus characters will be pushed off the left rather than ignored.
void | setMaxTextLength (size_t _value)
| Sets the max amount of text allowed in the edit field.
size_t | getMaxTextLength () const
| Gets the max amount of text allowed in the edit field.
void | insertText (const UString &_text, size_t _index=ITEM_NONE)
void | addText (const UString &_text)
void | eraseText (size_t _start, size_t _count=1)
void | setEditReadOnly (bool _value)
bool | getEditReadOnly () const
void | setEditPassword (bool _password)
bool | getEditPassword () const
void | setEditMultiLine (bool _value)
bool | getEditMultiLine () const
void | setEditStatic (bool _value)
bool | getEditStatic () const
void | setPasswordChar (Char _char)
void | setPasswordChar (const UString &_value)
Char | getPasswordChar () const
void | setEditWordWrap (bool _value)
bool | getEditWordWrap () const
void | setTabPrinting (bool _value)
bool | getTabPrinting () const
bool | getInvertSelected () const
void | setInvertSelected (bool _value)
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setVisibleVScroll (bool _value)
bool | isVisibleVScroll () const
size_t | getVScrollRange () const
size_t | getVScrollPosition () const
void | setVScrollPosition (size_t _index)
void | setVisibleHScroll (bool _value)
bool | isVisibleHScroll () const
size_t | getHScrollRange () const
size_t | getHScrollPosition () const
void | setHScrollPosition (size_t _index)
void | setFontName (std::string_view _value) override
void | setFontHeight (int _value) override
int | getFontHeight () const override
void | setTextAlign (Align _value) override
void | setTextColour (const Colour &_value) override
IntCoord | getTextRegion () const override
IntSize | getTextSize () const override
void | setTextShadowColour (const Colour &_value) override
void | setTextShadow (bool _value) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
Public Member Functions inherited from MyGUI::TextBox
template<typename Type>
bool | isType () const
std::string_view | getFontName () const
Align | getTextAlign () const
const Colour & | getTextColour () const
void | setCaptionWithReplacing (std::string_view _value)
const Colour & | getTextShadowColour () const
bool | getTextShadow () const
Public Member Functions inherited from MyGUI::Widget
template<typename Type>
bool | isType () const
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
Widget * | createWidgetT (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
template<typename T>
T * | createWidget (WidgetStyle _style, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_point)
void | setRealSize (const FloatSize &_size)
void | setRealCoord (const FloatCoord &_coord)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _alpha)
float | getAlpha () const
void | setInheritsAlpha (bool _inherits)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (std::string_view _name)
void | findWidgets (std::string_view _name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (std::string_view _layer={})
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, std::string_view _layer={})
void | changeWidgetSkin (std::string_view _skinName)
void | setWidgetStyle (WidgetStyle _style, std::string_view _layer={})
WidgetStyle | getWidgetStyle () const
void | setProperty (std::string_view _key, std::string_view _value)
virtual size_t | _getItemIndex (Widget *_item) const
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, std::string_view _skinName, Widget *_parent, ICroppedRectangle *_croppedParent, std::string_view _name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
bool | _setWidgetState (std::string_view _state)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type>
bool | isType () const
template<typename Type>
Type * | castType (bool _throw=true)
template<typename Type>
const Type * | castType (bool _throw=true) const
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
virtual | ~ICroppedRectangle ()=default
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (std::string_view _key, std::string_view _value)
std::string_view | getUserString (std::string_view _key) const
const MapString & | getUserStrings () const
bool | clearUserString (std::string_view _key)
bool | isUserString (std::string_view _key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType>
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType>
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (std::string_view _value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (std::string_view _texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::MemberObsolete< EditBox >
void | showVScroll (bool _visible)
bool | isShowVScroll ()
void | showHScroll (bool _visible)
bool | isShowHScroll ()
void | setTextColour (size_t _start, size_t _count, const Colour &_colour)
void | getTextSelect (size_t &_start, size_t &_end) const
UString | getText (size_t _start, size_t _count) const
void | setTextSelect (size_t _start, size_t _end)
void | deleteTextSelect ()
UString | getSelectedText () const
bool | isTextSelect ()
void | setTextSelectColour (const Colour &_colour)
Public Member Functions inherited from MyGUI::IItemContainer
virtual | ~IItemContainer ()=default
virtual Widget * | _getItemAt (size_t _index) const
virtual void | _setItemSelected (IItem *)
Public Member Functions inherited from MyGUI::MemberObsolete< ComboBox >
size_t | getItemIndexSelected () const
void | setItemSelectedAt (size_t _index)
void | clearItemSelected ()
void | insertItem (size_t _index, const UString &_name)
void | setItem (size_t _index, const UString &_item)
const UString & | getItem (size_t _index) const
void | deleteItem (size_t _index)
void | deleteAllItems ()
size_t | getItemSelect () const
void | resetItemSelect ()
void | setItemSelect (size_t _index)
void | setMaxListHeight (int _value)
int | getMaxListHeight () const

## Static Public Member Functions
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::EditBox
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::TextBox
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static std::string_view | getClassTypeName ()

## Data Fields
EventPairAddParameter< EventHandle_WidgetVoid, EventHandle_ComboBoxPtrSizeT > | eventComboAccept
EventPair< EventHandle_WidgetSizeT, EventHandle_ComboBoxPtrSizeT > | eventComboChangePosition
Data Fields inherited from MyGUI::EditBox
EventPair< EventHandle_WidgetVoid, EventHandle_EditPtr > | eventEditSelectAccept
EventPair< EventHandle_WidgetVoid, EventHandle_EditPtr > | eventEditTextChange
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
void | initialiseOverride () override
void | shutdownOverride () override
void | onKeyButtonPressed (KeyCode _key, Char _char) override
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::EditBox
void | initialiseOverride () override
void | shutdownOverride () override
void | onMouseDrag (int _left, int _top, MouseButton _id) override
void | onKeyLostFocus (Widget *_new) override
void | onKeySetFocus (Widget *_old) override
void | onKeyButtonPressed (KeyCode _key, Char _char) override
void | notifyMouseSetFocus (Widget *_sender, Widget *_old)
void | notifyMouseLostFocus (Widget *_sender, Widget *_new)
void | notifyMousePressed (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseReleased (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseDrag (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseButtonDoubleClick (Widget *_sender)
void | notifyScrollChangePosition (ScrollBar *_sender, size_t _position)
void | notifyMouseWheel (Widget *_sender, int _rel)
void | updateView ()
void | updateViewWithCursor ()
void | eraseView ()
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::TextBox
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::Widget
| ~Widget () override=default
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer, std::string_view _name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point) const
virtual void | baseUpdateEnable ()
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T>
void | assignWidget (T *&_widget, std::string_view _name)
VectorWidgetPtr | getSkinWidgetsByName (std::string_view _name) const
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (std::string_view _state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_item, bool _deep)
void | detachFromLayerItemNode (bool _deep)
Protected Member Functions inherited from MyGUI::ScrollViewBase
virtual | ~ScrollViewBase ()=default
void | updateScrollSize ()
void | updateScrollPosition ()
virtual void | eraseContent ()

## Additional Inherited Members
Protected Attributes inherited from MyGUI::EditBox
bool | mIsPressed {false}
bool | mIsFocus {false}
bool | mCursorActive {false}
float | mCursorTimer {0}
float | mActionMouseTimer {0}
size_t | mCursorPosition {0}
size_t | mTextLength {0}
size_t | mStartSelect {ITEM_NONE}
size_t | mEndSelect {0}
DequeUndoRedoInfo | mVectorUndoChangeInfo
DequeUndoRedoInfo | mVectorRedoChangeInfo
bool | mMouseLeftPressed {false}
bool | mModeReadOnly {false}
bool | mModePassword {false}
bool | mModeMultiline {false}
bool | mModeStatic {false}
bool | mModeWordWrap {false}
bool | mTabPrinting {false}
UString | mPasswordText
std::string | mOriginalPointer
Char | mCharPassword {'*'}
bool | mOverflowToTheLeft {false}
size_t | mMaxTextLength
ISubWidgetText * | mClientText {nullptr}
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin {false}
ICroppedRectangle * | mCroppedParent {nullptr}
Protected Attributes inherited from MyGUI::ScrollViewBase
ScrollBar * | mVScroll {nullptr}
ScrollBar * | mHScroll {nullptr}
Widget * | mScrollViewClient {nullptr}
bool | mVisibleHScroll {true}
bool | mVisibleVScroll {true}
size_t | mVRange {0}
size_t | mHRange {0}
bool | mChangeContentByResize {false}

## Detailed Description

widget description should be here.

Definition at line 28 of file MyGUI_ComboBox.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::ComboBox::Base

Definition at line 30 of file MyGUI_ComboBox.h.

## ◆ RTTIBase

typedef ComboBox MyGUI::ComboBox::RTTIBase

Definition at line 30 of file MyGUI_ComboBox.h.

## Member Function Documentation

## ◆ _addItem()

void MyGUI::ComboBox::_addItem | ( | const MyGUI::UString & | _name | ) |
| overridevirtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 559 of file MyGUI_ComboBox.cpp.

## ◆ _getItemCount()

size_t MyGUI::ComboBox::_getItemCount | ( |  | ) | const
| overridevirtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 554 of file MyGUI_ComboBox.cpp.

## ◆ _getItemNameAt()

const UString & MyGUI::ComboBox::_getItemNameAt | ( | size_t | _index | ) | const
| overridevirtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 574 of file MyGUI_ComboBox.cpp.

## ◆ _removeItemAt()

void MyGUI::ComboBox::_removeItemAt | ( | size_t | _index | ) |
| overridevirtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 564 of file MyGUI_ComboBox.cpp.

## ◆ _resetContainer()

void MyGUI::ComboBox::_resetContainer | ( | bool | _update | ) |
| overridevirtual

Reimplemented from MyGUI::Widget.

Definition at line 579 of file MyGUI_ComboBox.cpp.

## ◆ _setItemNameAt()

void MyGUI::ComboBox::_setItemNameAt | ( | size_t | _index,
|  | const UString & | _name )
| overridevirtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 569 of file MyGUI_ComboBox.cpp.

## ◆ addItem()

void MyGUI::ComboBox::addItem | ( | const UString & | _name,
|  | Any | _data = Any::Null )

Add an item to the end of a array.

Definition at line 470 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemAt()

void MyGUI::ComboBox::beginToItemAt | ( | size_t | _index | ) |

Move all elements so specified becomes visible.

Definition at line 495 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemFirst()

void MyGUI::ComboBox::beginToItemFirst | ( |  | ) |

Move all elements so first becomes visible.

Definition at line 500 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemLast()

void MyGUI::ComboBox::beginToItemLast | ( |  | ) |

Move all elements so last becomes visible.

Definition at line 506 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemSelected()

void MyGUI::ComboBox::beginToItemSelected | ( |  | ) |

Move all elements so selected becomes visible.

Definition at line 512 of file MyGUI_ComboBox.cpp.

## ◆ clearIndexSelected()

void MyGUI::ComboBox::clearIndexSelected | ( |  | ) |

Clear item selection.

Definition at line 480 of file MyGUI_ComboBox.cpp.

## ◆ clearItemDataAt()

void MyGUI::ComboBox::clearItemDataAt | ( | size_t | _index | ) |

Clear an item data at a specified position.

Definition at line 485 of file MyGUI_ComboBox.cpp.

## ◆ findItemIndexWith()

size_t MyGUI::ComboBox::findItemIndexWith | ( | const UString & | _name | ) |

Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.

Definition at line 372 of file MyGUI_ComboBox.cpp.

## ◆ getClassTypeName()

std::string_view MyGUI::ComboBox::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 30 of file MyGUI_ComboBox.h.

## ◆ getComboModeDrop()

bool MyGUI::ComboBox::getComboModeDrop | ( |  | ) | const

Get drop list mode flag.

Definition at line 518 of file MyGUI_ComboBox.cpp.

## ◆ getFlowDirection()

FlowDirection MyGUI::ComboBox::getFlowDirection | ( |  | ) | const

Get direction, where drop down list appears.

Definition at line 543 of file MyGUI_ComboBox.cpp.

## ◆ getIndexSelected()

size_t MyGUI::ComboBox::getIndexSelected | ( |  | ) | const

Get index of selected item (ITEM_NONE if none selected)

Definition at line 475 of file MyGUI_ComboBox.cpp.

## ◆ getItemCount()

size_t MyGUI::ComboBox::getItemCount | ( |  | ) | const

Get number of items.

Definition at line 465 of file MyGUI_ComboBox.cpp.

## ◆ getItemDataAt()

template<typename ValueType>

ValueType * MyGUI::ComboBox::getItemDataAt | ( | size_t | _index,
|  | bool | _throw = true )
| inline

Get item data from specified position.

Definition at line 80 of file MyGUI_ComboBox.h.

## ◆ getItemNameAt()

const UString & MyGUI::ComboBox::getItemNameAt | ( | size_t | _index | ) | const

Get item name from specified position.

Definition at line 490 of file MyGUI_ComboBox.cpp.

## ◆ getMaxListLength()

int MyGUI::ComboBox::getMaxListLength | ( |  | ) | const

Set max list length.

Definition at line 538 of file MyGUI_ComboBox.cpp.

## ◆ getSmoothShow()

bool MyGUI::ComboBox::getSmoothShow | ( |  | ) | const

Get smooth show of list flag.

Definition at line 528 of file MyGUI_ComboBox.cpp.

## ◆ getTypeName()

virtual std::string_view MyGUI::ComboBox::getTypeName | ( |  | ) | const
| inlineoverridevirtual

Get type name as string

Reimplemented from MyGUI::EditBox.

Definition at line 30 of file MyGUI_ComboBox.h.

## ◆ initialiseOverride()

void MyGUI::ComboBox::initialiseOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 26 of file MyGUI_ComboBox.cpp.

## ◆ insertItemAt()

void MyGUI::ComboBox::insertItemAt | ( | size_t | _index,
|  | const UString & | _item,
|  | Any | _data = Any::Null )

Insert an item into a array at a specified position.

Definition at line 334 of file MyGUI_ComboBox.cpp.

## ◆ isType() [1/2]

template<typename Type>

bool MyGUI::ComboBox::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 30 of file MyGUI_ComboBox.h.

## ◆ isType() [2/2]

virtual bool MyGUI::ComboBox::isType | ( | const std::type_info & | _type | ) | const
| inlineoverridevirtual

Compare with selected type

Reimplemented from MyGUI::EditBox.

Definition at line 30 of file MyGUI_ComboBox.h.

## ◆ onKeyButtonPressed()

void MyGUI::ComboBox::onKeyButtonPressed | ( | KeyCode | _key,
|  | Char | _char )
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 147 of file MyGUI_ComboBox.cpp.

## ◆ removeAllItems()

void MyGUI::ComboBox::removeAllItems | ( |  | ) |

Remove all items.

Definition at line 348 of file MyGUI_ComboBox.cpp.

## ◆ removeItemAt()

void MyGUI::ComboBox::removeItemAt | ( | size_t | _index | ) |

Remove item at a specified position.

Definition at line 341 of file MyGUI_ComboBox.cpp.

## ◆ setComboModeDrop()

void MyGUI::ComboBox::setComboModeDrop | ( | bool | _drop | ) |

Set drop list mode (text can not be edited)

Definition at line 354 of file MyGUI_ComboBox.cpp.

## ◆ setFlowDirection()

void MyGUI::ComboBox::setFlowDirection | ( | FlowDirection | _value | ) |

Set direction, where drop down list appears (TopToBottom by default).

Definition at line 377 of file MyGUI_ComboBox.cpp.

## ◆ setIndexSelected()

void MyGUI::ComboBox::setIndexSelected | ( | size_t | _index | ) |

Select specified _index.

Definition at line 306 of file MyGUI_ComboBox.cpp.

## ◆ setItemDataAt()

void MyGUI::ComboBox::setItemDataAt | ( | size_t | _index,
|  | Any | _data )

Replace an item data at a specified position.

Definition at line 327 of file MyGUI_ComboBox.cpp.

## ◆ setItemNameAt()

void MyGUI::ComboBox::setItemNameAt | ( | size_t | _index,
|  | const UString & | _name )

Replace an item name at a specified position.

Definition at line 320 of file MyGUI_ComboBox.cpp.

## ◆ setMaxListLength()

void MyGUI::ComboBox::setMaxListLength | ( | int | _value | ) |

Get max list length.

Definition at line 533 of file MyGUI_ComboBox.cpp.

## ◆ setPropertyOverride()

void MyGUI::ComboBox::setPropertyOverride | ( | std::string_view | _key,
|  | std::string_view | _value )
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 434 of file MyGUI_ComboBox.cpp.

## ◆ setSmoothShow()

void MyGUI::ComboBox::setSmoothShow | ( | bool | _value | ) |

Set smooth show of list.

Definition at line 523 of file MyGUI_ComboBox.cpp.

## ◆ shutdownOverride()

void MyGUI::ComboBox::shutdownOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 82 of file MyGUI_ComboBox.cpp.

## Field Documentation

## ◆ eventComboAccept

EventPairAddParameter<EventHandle_WidgetVoid, EventHandle_ComboBoxPtrSizeT> MyGUI::ComboBox::eventComboAccept

Event : Enter pressed in combo mode or item selected in drop down list and combo mode drop enabled (see void ComboBox::setComboModeDrop(bool _value)).
signature : void method(MyGUI::ComboBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | item

Definition at line 143 of file MyGUI_ComboBox.h.

## ◆ eventComboChangePosition

EventPair<EventHandle_WidgetSizeT, EventHandle_ComboBoxPtrSizeT> MyGUI::ComboBox::eventComboChangePosition

Event : Position changed.
signature : void method(MyGUI::ComboBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | of new position

Definition at line 150 of file MyGUI_ComboBox.h.

The documentation for this class was generated from the following files:

- MyGUI_ComboBox.h
- MyGUI_ComboBox.cpp